'mdIterator - by MOD
'20130915

'http://docs.oracle.com/javase/6/docs/api/java/util/Iterator.html


#Ifndef Boolean
	#Define Boolean Integer
#EndIf
#Ifndef FALSE
	#Define FALSE 0
	#Define TRUE (Not FALSE)
#EndIf
#Ifndef NULL
	#Define NULL CPtr(Any Ptr, 0)
#EndIf

#Macro ForEach(T, var_, object_)
	Scope
	Dim As mdIterator##T var_##mdIterator##T = object_.iterator()
	While var_##mdIterator##T.hasNext()
		var_ = var_##mdIterator##T.nex()
#EndMacro

#Ifndef In
#Define In ,
#Define NextEach Wend : End Scope
#EndIf

#Define mdIterator(E) mdIterator##E
#Macro mdIteratorDeclare(E)

#Ifndef mdIterator##E
'#Define __MDITERATOR_BI__

Type mdIterator##E
	Public:
	Declare Constructor (node As mdBasicNode##E Ptr)
	Declare Function hasNext() As Boolean
	Declare Function nex() As E
	Declare Sub remove()
	
	Private:
	pre As mdBasicNode##E Ptr
	cur As mdBasicNode##E Ptr
End Type

Constructor mdIterator##E (node As mdBasicNode##E Ptr)
	This.cur = node
End Constructor

Function mdIterator##E.hasNext() As Boolean
	Return This.cur <> NULL
End Function

Function mdIterator##E.nex() As E
	This.pre = This.cur
	This.cur = This.cur->nex
	Return This.pre->value
End Function

Sub mdIterator##E.remove()
	This.pre->value = This.cur->value
	This.pre->nex = This.cur->nex
	Delete This.cur
	This.cur = This.pre->nex
End Sub

#EndIf '__MDITERATOR_BI__

#EndMacro